# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import popuplib
import playerlib
import cmdlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')
block  = es.import_addon('sam/base/pcontrol')

filters = {'#all':'#alive','#alive':'#alive','#ct':'#ct','#t':'#t'}
healthtag     = '#greenHEALTH'
health_hudtag = 'HEALTH'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### CMDs ###
	cmdlib.registerSayCommand('!health', sethealthCMD,'SAM')
	cmdlib.registerSayCommand('!sam_health', sethealthCMD,'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Unreg ###
	cmdlib.unregisterSayCommand('!health')
	cmdlib.unregisterSayCommand('!sam_health')

	### Popups ###
	func.popupDelete('set_health')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def sethealthCMD(userid, args):
	admin = playerlib.getPlayer(userid)
	if admins.isAdmin(admin.steamid):
		if admins.checkAccess(admin.steamid, 'Set Health'):
			if args:
				try:
					if int(args[1]) in range(1,251):
						if not args[0] in filters:
							target = playerlib.getPlayer(es.getuserid(args[0]))
							if admins.checkImmunity(es.getplayersteamid(userid), target.steamid): set_health(admin, {'target':target,'num':args[1]}, None, 0, 1)
						else:
							list = [ply for ply in playerlib.getPlayerList(filters[args[0]]) if admins.checkImmunity(es.getplayersteamid(userid), ply.steamid, 0)]
							if len(list) > 0:
								for ply in list: set_health(admin, {'target':ply,'num':args[1]}, None, 1, 1)
								func.tell('#all', func.lang_pcontrol('sethealth_to_targets', {'num':len(list),'health':args[1]}), healthtag)
					else: func.hudhint(userid, func.lang_pcontrol('sethealth_not_in_range'), health_hudtag)
				except (ValueError, IndexError): func.hudhint(userid, func.lang_pcontrol('sethealth_not_in_range'), health_hudtag)
				except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), health_hudtag)
			else: block.function(userid, 'Set Health', None)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid, target):
	func.popupDelete('set_health')
	popup = popuplib.easymenu('set_health', None, set_health)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('pcontrol_sethealth')))
	popup.setdescription('\n # %s' % func.lang_titles('pcontrol_sethealth_howmuch_desc'))
	popup.addoption({'target':target,'num':1}, 1)
	num = 5
	while num < 105:
		popup.addoption({'target':target,'num':num}, num)
		num += 5
	popup.addoption({'target':target,'num':250}, 250)
	popup.submenu(10, 'pcontrol')
	popup.send(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def set_health(userid, choice, popup, cmd=0, menu=0):
	target = choice['target']
	target.setHealth(int(choice['num']))
	if cmd == 0: func.tell('#all', func.lang_pcontrol('sethealth_to_target', {'target':target.name,'health':choice['num']}), healthtag)
	if menu == 0: moduleAction(userid, playerlib.getPlayer(target))

# ============================================================================================================================================================= #