# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import playerlib
import popuplib
import cmdlib
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')
block  = es.import_addon('sam/base/pcontrol')

# * VARIABLES

respawntag     = '#greenRESPAWN'
respawn_hudtag = 'RESPAWN'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### CMDs ###
	cmdlib.registerSayCommand('!respawn', respawnCMD,'SAM')
	cmdlib.registerSayCommand('!sam_respawn', respawnCMD,'SAM')

# ============================================================================================================================================================== #
# ========================================================================= UNLOAD ============================================================================= #
# ============================================================================================================================================================== #
def unload():
	### Unreg ###
	cmdlib.unregisterSayCommand('!respawn')
	cmdlib.unregisterSayCommand('!sam_respawn')

	### Popups ###
	func.popupDelete('respawn_plist')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def respawnCMD(userid, args):
	admin = playerlib.getPlayer(userid)
	if admins.isAdmin(admin.steamid):
		if admins.checkAccess(admin.steamid, 'Respawn'):
			if args:
				try:
					target = playerlib.getPlayer(es.getuserid(args[0]))
					if admins.checkImmunity(es.getplayersteamid(userid), target.steamid): respawnTarget(admin, playerlib.getPlayer(es.getuserid(args[0])), None, 1)
				except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), respawn_hudtag)
			else: block.function(userid, 'Respawn', None)

# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def moduleAction(userid):
	ct = playerlib.getPlayerList('#ct')
	t  = playerlib.getPlayerList('#t')
	if len(ct) > 0 or len(t) > 0:
		func.popupDelete('respawn_plist')
		popup = popuplib.easymenu('respawn_plist', None, respawnTarget)
		popup.c_beginsep = func.pline
		popup.c_pagesep  = func.pline
		popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('pcontrol_respawn')))
		popup.setdescription('\n # %s' % func.lang_titles('choose_player'))
		for x in (ct, t):
			for ply in x: popup.addoption(ply, ply.name)
		popup.submenu(10, 'pcontrol')
		popup.send(userid)
	else:
		func.hudhint(userid, func.lang_pcontrol('empty_teams'))
		block.modulePopup(userid)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def respawnTarget(userid, target, popup, cmd=0):
	if admins.checkImmunity(es.getplayersteamid(userid), target.steamid):
		es.setplayerprop(target, 'CCSPlayer.m_iPlayerState', 0)
		es.setplayerprop(target, 'CCSPlayer.baseclass.m_lifeState', 512)
		es.server.insertcmd('es_xspawnplayer %s' % target)
		func.tell('#all', func.lang_pcontrol('respawn_target', {'target':target.name}), respawntag)
	if cmd == 0: moduleAction(userid)

# ============================================================================================================================================================== #
